#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "model_type.h"
#include "vmf_nnm_inference_app.h"
#include "vmf_nnm_fifoq_manager.h"
#include "my_kl630_sin_example_inf.h"
#include "classifier_post_process.h"
#include "model_res.h"
#include "inference_config.h"

#define CLASS_NUM 4 // 공정에 따라

typedef enum {
    KP_APP_PD_CLASS_Proc0 = 0,
    KP_APP_PD_CLASS_Proc1 = 1,
    KP_APP_PD_CLASS_Proc2 = 2,
    KP_APP_PD_CLASS_Proc3 = 3
} kp_app_pd_class_t;

// Define enum for class labels of pedestrian detection results.
struct Video_classification_result_s {
    int class_ID[CLASS_NUM];
    float class_score[CLASS_NUM ];
};

// for pedestrian detection result, should be in DDR
//static struct classifier_result_s *_classifier_result = NULL;
static struct Video_classification_result_s *_classifier_result  =NULL;
 
//static struct classifier_result_s *_classifier_result = NULL;



// this app needs extra DDR buffers for ncpu result
static bool is_init = false;


// YJ 추가 240912
int find_max_score_index(struct Video_classification_result_s *_3DCNN_result ) {
    /*
    if (_3DCNN_result != NULL && _3DCNN_result->score != NULL) {
        std::cerr << "Error: Invalid _3DCNN_result or score is NULL" << std::endl;
        return -1; // 에러 처리: NULL 포인터 확인
    }
   */
    int max_index = 0;
    //float max_score = std::numeric_limits<float>::lowest(); // 최소값으로 초기화
    float max_score = 0; 

    // _3DCNN_result->count[0]을 클래스의 개수로 가정
    //int num_classes = _3DCNN_result->count[0];
    
    
    int num_classes = 4;
    //const int num_classes = KP_APP_PD_CLASS_Proc3 - KP_APP_PD_CLASS_Proc0;

    for (int i = 0; i < num_classes; i++) {
        if (_3DCNN_result->class_score[i] > max_score) {
            max_score = _3DCNN_result->class_score[i];
            max_index = i;
        }
    }

    return max_index;
}

static bool init_temp_buffer()
{
    // Debugging: Print message to indicate function entry
    printf("Entering init_temp_buffer function.\n");
    fflush(stdout);  // Ensure the output is flushed immediately
    
    // inf_config 변수 선언
    inference_config_t inf_config;
    
    // Allocate DDR memory for ncpu/npu output result
    //_classifier_result = (struct classifier_result_s *)calloc(1, sizeof(struct classifier_result_s));
    _classifier_result = (struct Video_classification_result_s *)calloc(1, sizeof(struct Video_classification_result_s));
    if (NULL == _classifier_result) {
        printf("Error: Memory allocation failed for _classifier_result\n");
        fflush(stdout);
        return false;
    } else {
        printf("Memory allocated for _classifier_result at address: %p\n", (void *)_classifier_result);
        fflush(stdout);
    }

    // Initialize the score array inside _classifier_result
    for (int i = 0; i < CLASS_NUM; i++) {  // CLASSIFIER_MAX_NUM is score array size
        _classifier_result->class_ID[i] = 0;  // Array factors initialize
        _classifier_result->class_score[i] = 0.0f;  // Array factors initialize
    }
    // 디버깅: 메모리 초기화 확인
    printf("Score[0]: %f\n", _classifier_result->class_score[0]);  // 첫 번째 score 값을 출력하여 초기화 확인
    printf("ID[0]: %d\n", _classifier_result->class_ID[0]);  // 첫 번째 score 값을 출력하여 초기화 확인
    // Set ncpu_result_buf to allocated memory and check
    inf_config.ncpu_result_buf = (void *)_classifier_result;

    printf("Set Output Buffer Address to: %p\n", inf_config.ncpu_result_buf);
    if (inf_config.ncpu_result_buf == NULL) {
        printf("Error: Output buffer is NULL after allocation!\n");
        return false;
    }

    return true;
}


static bool deinit_temp_buffer()
{
    if (is_init == true) {
        // Free DDR memory for ncpu/npu output result
        if (_classifier_result) {
            free(_classifier_result);
        }

        is_init = false;
    }

    return true;
}

static int inference_video_classification(my_kl630_sin_example_header_t *_input_header,
                                          struct Video_classification_result_s *_3DCNN_result /* output */,
                                          kp_app_pd_class_t *pd_class /* output */)
{

    //printf("Check_ERROR 1 \n");
    // Config image preprocessing and model settings
    VMF_NNM_INFERENCE_APP_CONFIG_T inf_config;
    memset(&inf_config, 0, sizeof(VMF_NNM_INFERENCE_APP_CONFIG_T));  // For safety let default 'bool' to 'false'

    // Image buffer address should be just after the header
    inf_config.num_image = 15;  // For 15fps
    inf_config.image_list[0].image_buf = (void *)((uint32_t)_input_header + sizeof(my_kl630_sin_example_header_t));
    inf_config.image_list[0].image_width = _input_header->width;
    inf_config.image_list[0].image_height = _input_header->height;
    inf_config.image_list[0].image_channel = 3;
    //inf_config.image_list[0].image_format = KP_IMAGE_FORMAT_RGB565;      // Assume RGB565
    inf_config.image_list[0].image_format = KP_IMAGE_FORMAT_YUV420;     // Assume yuv420
    inf_config.image_list[0].image_norm = KP_NORMALIZE_KNERON;          // This depends on model
    inf_config.image_list[0].image_resize = KP_RESIZE_ENABLE;           // Default: enable resize
    inf_config.image_list[0].image_padding = KP_PADDING_DISABLE;        // Default: disable padding

    inf_config.model_id = MODELS_630_3DCNN;  // This depends on model

    printf("Inference Configuration: Image Width: %d, Height: %d\n", _input_header->width, _input_header->height);

    // Set up fd result output buffer for ncpu/npu
    inf_config.ncpu_result_buf = (void *)_classifier_result;


    // Debugging: Model ID and Output Buffer
    printf("Model ID: %d, Output Buffer: %p\n", inf_config.model_id, inf_config.ncpu_result_buf);

     inf_config.post_proc_func = classifier_post_process;

    
    // Debugging: Output buffer address 확인
    printf("Output Buffer Address: %p\n", (void *)inf_config.ncpu_result_buf);
    printf("Check_ERROR 2 \n");
    if (inf_config.ncpu_result_buf == NULL) {
    printf("Error: Output buffer is NULL after allocation!\n");
    printf("Check_ERROR 2.1 \n"); 
    }
    
    // Debugging: About to execute inference with the current model ID
    printf("About to execute inference with model ID: %d\n", inf_config.model_id);
    
    // Execute the inference
    int result = VMF_NNM_Inference_App_Execute(&inf_config); //여기서 ERROR 발생: CODE  110, KP_SUCCESS 되어야함
   
     printf("Check_ERROR 2.2 \n");
   
     

    // Debugging print to check after inference execution
    printf("After inference execution: Result: %d\n", result);
    if (result != KP_SUCCESS) {
    printf("Inference failed with result code: %d\n", result);
    }

    // Check if inference was successful and set the classification result
    if (result == KP_SUCCESS && _3DCNN_result != NULL && _3DCNN_result->class_score != NULL) {
        // Check the score array's first element and map it to kp_app_pd_class_t
	//int class_PROC = _3DCNN_result->Video_classification_result.class_ID[0]; // 첫 번째 class 만 사용한다고 가정
	/*
	int class_PROC = 0;
        float class_Prob = _3DCNN_result->score[0]; // 첫 번째 스코어 값만 사용한다고 가정
       */
        //YJ 240912 추가 - 향후 테스트 필요
		
        int max_Prob_idx = find_max_score_index(_3DCNN_result); // max_Prob_idx를 찾아줌
	int class_PROC = _3DCNN_result->class_ID[max_Prob_idx]; // 해당 idx 사용한다고 가정
	//int class_PROC = 0;
        float class_Prob = _3DCNN_result->class_score[max_Prob_idx]; // 해당 idx 사용한다고 가정
	      
        // Debugging print to check the result and first score value
        printf("Class Result: %d, Prob Score: %f\n", class_PROC , class_Prob );


        *pd_class = class_PROC;
    } 
    else {
        printf("Inference execution failed or result is invalid.\n");
        result = KP_FW_DDR_MALLOC_FAILED_102;  // 적절한 에러 코드 반환
    }

    // 디버깅: 추론 결과를 반환하기 전에 결과 값 확인
    // result: 추론 상태에 대한 상태
    // pd_class: 몇번째 class 인지

    
    printf("Final Result: %d, Mapped Class: %d\n", result, *pd_class);
    
    return result;
}



//////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

void my_kl630_sin_example_inf(int job_id, int num_input_buf, void **inf_input_buf_list)
{
    // 'inf_input_buf'와 'inf_result_buf'는 kdp2 미들웨어에서 제공됨
    // 'inf_input_buf'의 내용은 호스트 SW에서 전송된 헤더 + 이미지임
    // 'inf_result_buf'는 ncpu/npu의 추론 결과를 호스트 SW로 다시 전달하는 데 사용됨

    // 가용한 결과 버퍼를 가져옴
    if (1 != num_input_buf) {
        VMF_NNM_Fifoq_Manager_Status_Code_Enqueue(job_id, KP_FW_WRONG_INPUT_BUFFER_COUNT_110);
        return;
    }

    int inf_status;
    int result_buf_size;
    uint32_t inf_result_buf;
    uint32_t inf_result_phy_addr;

    if (KP_SUCCESS != VMF_NNM_Fifoq_Manager_Result_Get_Free_Buffer(&inf_result_buf, &inf_result_phy_addr, &result_buf_size, -1)) {
        printf("[%s] get result free buffer failed\n", __FUNCTION__);
        return;
    }

    my_kl630_sin_example_header_t *input_header = (my_kl630_sin_example_header_t *)inf_input_buf_list[0];
    my_kl630_sin_example_result_t *output_result = (my_kl630_sin_example_result_t *)inf_result_buf;

    // 결과 헤더를 사전에 설정
    output_result->header_stamp.magic_type = KDP2_MAGIC_TYPE_INFERENCE;
    output_result->header_stamp.total_size = sizeof(my_kl630_sin_example_result_t);
    output_result->header_stamp.job_id = job_id;

    if (!is_init) {
        int status = init_temp_buffer();
        if (!status) {
            // 호스트 에러 알림!
            output_result->header_stamp.status_code = KP_FW_DDR_MALLOC_FAILED_102;
            VMF_NNM_Fifoq_Manager_Result_Enqueue(inf_result_buf, inf_result_phy_addr, result_buf_size, -1, false);
            return;
        }

        is_init = true;
    }
     // 디버깅: 추론 함수 호출 전에 메시지 출력
    printf("Calling inference function...\n");

    kp_app_pd_class_t pd_class;
    inf_status = inference_video_classification(input_header, _classifier_result, &pd_class);

    if (KP_SUCCESS != inf_status) {
        // 호스트 에러 알림!
        output_result->header_stamp.status_code = inf_status;
        VMF_NNM_Fifoq_Manager_Result_Enqueue(inf_result_buf, inf_result_phy_addr, result_buf_size, -1, false);
        return;
    }

    // 디버깅: 추론 상태와 결과 확인
    printf("Class ID: %d\n", pd_class);
    //printf("Class Score: %f\n", _classifier_result->class_score[0]);  // Dereference pointer

    // 결과 업데이트
    output_result->Video_classification_result.class_ID = pd_class;
    output_result->Video_classification_result.class_score = _classifier_result->class_score[0];  // Dereference pointer

    // 디버깅: 업데이트 후 결과 값 확인
    printf("Updated Class ID: %d, Updated Class Score: %f\n", 
        output_result->Video_classification_result.class_ID, 
        output_result->Video_classification_result.class_score);

    output_result->header_stamp.status_code = inf_status;

    VMF_NNM_Fifoq_Manager_Result_Enqueue(inf_result_buf, inf_result_phy_addr, result_buf_size, -1, false);
}

//////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

void my_kl630_sin_example_inf_deinit()
{
    deinit_temp_buffer();
}